unit ExeMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

//-----------------------------------------------------------------------------
//  ԍŏsNX
type
    TExecuteProc = procedure() of object;

    TTimeLagExecuter = class(TThread)
    private
        FTick: Cardinal;
        procedure ExecProc();
    public
        TimeLag: Cardinal;
        ExecuteProc: TExecuteProc;
    protected
        procedure Execute(); override;
        procedure Reserve();
        procedure Cancel();
    public
        constructor Create();
    end;

//-----------------------------------------------------------------------------
//  tH[
type
  TMainForm = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    Timer1: TTimer;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    WndProc: TWndMethod;
    procedure CustomWndProc(var Msg: TMessage);
    procedure HookedMouseProc(const Msg: TMessage);
    procedure HookedShellProc(const Msg: TMessage);
    procedure MessageOut(const AMsg: String);
  private
    FPrevTick: Cardinal;
    FPrevPID: Cardinal;
    procedure OnDoubleClickDesktop();
  private
    FExecuter: TTimeLagExecuter;
  end;

var
    MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    ExeInfo;

const
    HOOK_DLL_NAME = 'PasteItHook.dll';

//=============================================================================
//  UTILITY

//-----------------------------------------------------------------------------
//  DLLC|[gEăX^eBbNN
function HookInstall(Wnd: HWND): Boolean; stdcall;external HOOK_DLL_NAME;
procedure  HookUnInstall(); stdcall;external HOOK_DLL_NAME;

//-----------------------------------------------------------------------------
//  NX擾
//  Win32 API by Object Pascal of Delphi
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html#VChap6-7
function GetClassNameStr(const hWindow:HWND):string;
var
  p:PChar;
  ret:integer;
begin
  GetMem(p,100);
  ret := GetClassName(hWindow,p,100);
  SetString(result,p,ret);
  FreeMem(p);
end;

//-----------------------------------------------------------------------------
//  EBhE̍ŏĩEBhE擾
//  Win32 API by Object Pascal of Delphi
function GetMostTopLevelWindow(const hWindow:HWND):HWND;
var
  hAncestor,hPrev:HWND;
begin
  hPrev := hWindow;
  hAncestor := GetParent(hPrev);
  while hAncestor <> 0  do begin
    hPrev := hAncestor;
    hAncestor := GetParent(hPrev)
  end;
  hAncestor := hPrev;
  while hAncestor <> 0  do begin
    hPrev := hAncestor;
    hAncestor := GetWindow(hPrev,GW_OWNER)
  end;
  result := hPrev;
end;

//-----------------------------------------------------------------------------
//  J[\nh擾
function GetCursorHandle(): HCURSOR;
var
    LCursorInfo: TCursorInfo;
begin
    FillChar(LCursorInfo, SizeOf(LCursorInfo), 0);
    LCursorInfo.cbSize := SizeOf(LCursorInfo);
    GetCursorInfo(LCursorInfo);
    Result := LCursorInfo.hCursor;
end;

//=============================================================================
//  ԍŏsNX

//-----------------------------------------------------------------------------
//  RXgN^
constructor TTimeLagExecuter.Create();
begin
    inherited Create(True);

    //  ҂ԏl
    TimeLag := 500;
    FTick := 0;

    //  s֐
    ExecuteProc := nil;
end;

//-----------------------------------------------------------------------------
//  s
procedure TTimeLagExecuter.ExecProc();
begin
    if Assigned(ExecuteProc) then
    begin
        ExecuteProc();
    end;
end;

//-----------------------------------------------------------------------------
//  \
procedure TTimeLagExecuter.Reserve();
begin
    FTick := GetTickCount();
end;

//-----------------------------------------------------------------------------
//  LZ
procedure TTimeLagExecuter.Cancel();
begin
    FTick := 0;
end;

//-----------------------------------------------------------------------------
//  C[v
procedure TTimeLagExecuter.Execute();
var
    LPrevCursor: HCURSOR;
    LCurrCursor: HCURSOR;
begin
    inherited;

    LPrevCursor := GetCursorHandle();

    while not Terminated do
    begin
        Sleep(1);

        //  J[\ύXꂽL킳LZ
        LCurrCursor := GetCursorHandle();
        if (LPrevCursor <> LCurrCursor) then
        begin
            Cancel();
            LPrevCursor := LCurrCursor;
        end;

        if (FTick > 0) and (GetTickCount() - FTick > TimeLag) then
        begin
            //  s
            Synchronize(ExecProc);
            Cancel();
        end;
    end;
end;

//=============================================================================
//  tH[

//-----------------------------------------------------------------------------
//  bZ[W\
procedure TMainForm.MessageOut(const AMsg: String);
var
    NowStr: string;
begin
    NowStr := FormatDateTime('yyyy/mm/dd hh:nn:ss:zzz', Now);
    Memo1.Lines.Add(NowStr + ' ' + AMsg);
end;

//-----------------------------------------------------------------------------
//  tH[RXgN^
procedure TMainForm.FormCreate(Sender: TObject);
begin
    FPrevTick := 0;
    FPrevPID := 0;

    //  ^COts쐬
    FExecuter := TTimeLagExecuter.Create();
    FExecuter.TimeLag := 500;
    FExecuter.ExecuteProc := OnDoubleClickDesktop;
    FExecuter.Resume();

    //  EBhEvV[WobNAbv
    WndProc := Self.WindowProc;
    //  ւ
    Self.WindowProc := CustomWndProc;
    //  tbNCXg[
    HookInstall(Self.Handle);
end;

//-----------------------------------------------------------------------------
//  tH[fXgN^
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  Ô߃ACXg[
    HookUnInstall();
    //  Ô߃EBhEvV[W߂
    Self.WindowProc := WndProc;

    //  ^COtsj
    FExecuter.Cancel();
    FExecuter.Terminate();
    FExecuter.Free();
end;

//-----------------------------------------------------------------------------
//  o[W
procedure TMainForm.Button1Click(Sender: TObject);
begin
    ShowInfoForm();
end;

//-----------------------------------------------------------------------------
//  ւpEBhEvV[W
procedure TMainForm.CustomWndProc(var Msg: TMessage);
begin
    //  DLL Ō߂ }EXtbNp̃bZ[W ID Ɣr
    case Msg.Msg of
        WM_APP + 2: HookedMouseProc(Msg);
        WM_APP + 3: HookedShellProc(Msg);
    end;

    //  낤Ƃ͌ĂԁB
    WndProc(Msg);
end;

//-----------------------------------------------------------------------------
//  HookedMouseProc mF
procedure TMainForm.HookedMouseProc(const Msg: TMessage);
var
    LPoint: TPoint;
    LHandle: HWND;
    LClassName: String;
begin
    //  _Ń}EX̐^ɂEBhE擾
    GetCursorPos(LPoint);
    LHandle := WindowFromPoint(LPoint);
    //  eq֌Ŵڂ
    LHandle := GetMostTopLevelWindow(LHandle);
    //  NX擾
    LClassName := UpperCase(GetClassNameStr(LHandle));
    //  fXNgbv?
    if (LClassName = 'PROGMAN') then
    begin
        case Msg.WParam of
            //WM_MBUTTONDBLCLK: MessageOut('WM_MBUTTONDBLCLK');
            //WM_LBUTTONDBLCLK: MessageOut('WM_LBUTTONDBLCLK');
            WM_MBUTTONDBLCLK,
            WM_LBUTTONDBLCLK:   FExecuter.Reserve();
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  HookedShellProc mF
procedure TMainForm.HookedShellProc(const Msg: TMessage);
var
    LProcessID: Cardinal;
    LTick: Cardinal;
begin
    //  쐬EBhẼvZXID́H
    GetWindowThreadProcessId(Msg.WParam, LProcessID);

    //  ̎Ԃ?
    LTick := GetTickCount();

    //  Oł쐬EBhẼvZXIDƔr
    if (LProcessID = FPrevPID) then
    begin
        //  1bȓȂ炨ȂvZXƔF
        if (LTick - FPrevTick < 1000) then
        begin
            //  ԂXV
            FPrevTick := LTick;
            Exit;
        end;
    end;

    //  ԂƃvZXIDL^
    FPrevTick := LTick;
    FPrevPID := LProcessID;

    //  fobOO
    MessageOut(Format('HSHELL_WINDOWCREATED(PID=%d)', [Msg.WParam]));
    FExecuter.Cancel();
end;

//-----------------------------------------------------------------------------
//  fXNgbv_uNbNꂽ
procedure TMainForm.OnDoubleClickDesktop();
begin
    MessageOut('fXNgbv_uNbN܂B');
end;


end.

